project/LoVisto/urls.py
from django.urls import path, re_path
from . import views
from django.views.generic.base import RedirectView
from django.contrib.staticfiles.storage import staticfiles_storage

urlpatterns = [

    path("", views.index),
    path('login_user', views.login_user),
    path('logout', views.logout_view),
    path('info', views.app_info),
    path('user', views.user),
    path('all', views.all_resources),
    re_path(r'resources/(?P<site>.+)\/(?P<resource>.+)', views.get_resource),

    # Acceso a los archivos estáticos
    path('css/dark.css', RedirectView.as_view(url=staticfiles_storage.url("LoVisto/css/dark.css"))),
    path('css/styles.css', RedirectView.as_view(url=staticfiles_storage.url("LoVisto/css/styles.css"))),
    path('images/banner.png', RedirectView.as_view(url=staticfiles_storage.url("LoVisto/images/banner.png"))),
    path('favicon.ico', RedirectView.as_view(url=staticfiles_storage.url("LoVisto/images/favicon.ico"))),
]

project/project/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [

    path('', include('LoVisto.urls')),
    path('admin/', admin.site.urls),
]

project/LoVisto/models.py
from django.db import models


class Content(models.Model):
    title = models.CharField(max_length=128)
    site = models.CharField(max_length=128)
    resource = models.CharField(max_length=128)
    description = models.TextField(blank=False)
    date = models.DateTimeField('published')
    info = models.TextField()
    user = models.CharField(max_length=200, default='None')
    comments = models.IntegerField(default=0)
    likes = models.IntegerField(default=0)
    dislikes = models.IntegerField(default=0)

    def __str__(self):
        return self.user + ": " + self.title


class Comment(models.Model):
    content = models.ForeignKey(Content, on_delete=models.CASCADE)
    title = models.CharField(max_length=200)
    body = models.TextField(blank=False)
    date = models.DateTimeField('published')
    user = models.CharField(max_length=200, default='None')

    def __str__(self):
        return self.content.title + ": " + self.title


class Vote(models.Model):
    TYPE = [
        (1, 'like'),
        (-1, 'dislike'),
    ]

    content = models.ForeignKey(Content, on_delete=models.CASCADE)
    user = models.CharField(max_length=200, default='None')
    decision = models.IntegerField(choices=TYPE)

    def __str__(self):
        return self.user + ": " + self.content.title

project/LoVisto/views.py
import re
import urllib
import urllib.error
import urllib.request

from django.contrib.auth import authenticate, login, logout
from django.shortcuts import redirect, render
from django.views.decorators.csrf import csrf_exempt
from django.http import JsonResponse
from django.utils import timezone

from .models import Content, Comment, Vote
from . import data

# Parsers
from .reddit_parser import RedditParser
from .wiki_parser import Wiki
from .youtube_parser import Video
from .aemet_parser import Aemet
from .html_parser import WebContent

# Inicializamos variable global con el archivo css por defecto de nuestras páginas
css_file = "LoVisto/css/styles.css"


@csrf_exempt
def app_info(request):
    """
    Procesamos peticiones del resurso '/info'.
    Se trata de la página de información de nuestra aplicación.
    """
    global css_file

    # Si hemos pulsado el botón de "Cambiar modo" en esta página, establecemos el css
    # correspondiente
    if request.method == "POST":
        if request.POST['action'] == "Cambiar modo":
            if css_file == "LoVisto/css/dark.css":
                css_file = "LoVisto/css/styles.css"
            else:
                css_file = "LoVisto/css/dark.css"

    # Añadimos la información para los enlaces del footer y el resto de datos del contexto
    lastsites = Content.objects.all().order_by('date').reverse()[:3]
    context = {"css_file": css_file, "csrf_token": csrf_exempt, "page": "/info", "lastsites": lastsites}

    # Renderizamos la plantilla
    return render(request, 'LoVisto/info.html', context=context, status=200)


@csrf_exempt
def processWikiInfo(resource):
    """
    Extraemos la información extendida de un recurso reconocido de wikipedia.
    Utilizamos el wiki_parser.py para extraerla y componer la plantilla que irá
    guardada como un string en la base de datos
    """
    info = ""

    # Diferenciamos imagen y texto
    article = resource.split('/', maxsplit=1)[1]
    text_url = "https://es.wikipedia.org/w/api.php?action=query&format=xml&titles=" + article + "&prop=extracts&exintro&explaintext"
    img_url = "https://es.wikipedia.org/w/api.php?action=query&titles=" + article + "&prop=pageimages&format=json&pithumbsize=100"

    try:
        textStream = urllib.request.urlopen(text_url)
        imgStream = urllib.request.urlopen(img_url)

        wiki = Wiki(textStream, imgStream)
        txt, img = wiki.info()

        # Generamos el html a partir de los datos que nos da el wiki_parser
        info = data.WIKI.format(titulo=txt['titulo'],
                                texto=txt['texto'],
                                imagen=img['imagen'],
                                url="http://es.wikipedia.org/" + resource)

    except urllib.error.HTTPError as err:
        print("catched: " + str(type(err)))
        print('HTTPError: {}'.format(err.code))
        pass
    except urllib.error.URLError as err:
        print("catched: " + str(type(err)))
        print('HTTPError: {}'.format(err.code))
        pass

    return info


@csrf_exempt
def processAemetInfo(resource):
    """
    Extraemos la información extendida de un recurso reconocido de aemet.
    Utilizamos el aemet_parser.py para extraerla y componer la plantilla que irá
    guardada como string en la base de datos
    """
    info = ""

    # Accedemos al archivo XML del aporte y extraemos la información extendida
    resource_id = resource.split('-id', maxsplit=1)[1]
    url = "https://www.aemet.es/xml/municipios/localidad_" + resource_id + ".xml"

    try:
        xmlStream = urllib.request.urlopen(url)
        aemet = Aemet(xmlStream)
        general, days = aemet.predicciones()

        # Generamos el html a partir de los datos que nos da el aemet_parser
        info = data.CABECERA.format(municipio=general['municipio'],
                                    provincia=general['provincia'])

        for day in days:
            info = info + data.DAY.format(tempMin=day['tempMin'],
                                          tempMax=day['tempMax'],
                                          sensMin=day['sensMin'],
                                          sensMax=day['sensMax'],
                                          humMin=day['humMin'],
                                          humMax=day['humMax'],
                                          fecha=day['fecha'])

        info = info + data.COPYRIGHT.format(copy=general['copyright'],
                                            url="www.aemet.es/" + resource)

    except urllib.error.HTTPError as err:
        print("catched: " + str(type(err)))
        print('HTTPError: {}'.format(err.code))
        pass
    except urllib.error.URLError as err:
        print("catched: " + str(type(err)))
        print('HTTPError: {}'.format(err.code))
        pass

    return info


@csrf_exempt
def processVideoInfo(resource):
    """
    Extraemos la información extendida de un recurso reconocido de youtube.
    Utilizamos el youtube_parser.py para extraerla y componer la plantilla que irá
    guardada como string en la base de datos.
    """

    info = ""

    # Accedemos al archivo JSON del aporte y extraemos la información extendida
    resource = resource.split('v=', maxsplit=1)[1]

    try:
        url = "https://www.youtube.com/oembed?format=json&url=https://www.youtube.com/watch?v=" + resource
        jsonStream = urllib.request.urlopen(url)
        video = Video(jsonStream)
        information = video.info()

        # Generamos el html con la información extendida del vídeo
        info = data.VIDEO.format(titulo=information['titulo'],
                                 video=information['video'],
                                 nombre_autor=information['nombre_autor'],
                                 link_autor=information['link_autor'],
                                 url=resource)

    except urllib.error.HTTPError as err:
        print("catched: " + str(type(err)))
        print('HTTPError: {}'.format(err.code))
        pass
    except urllib.error.URLError as err:
        print("catched: " + str(type(err)))
        print('HTTPError: {}'.format(err.code))
        pass

    return info


@csrf_exempt
def processRedditInfo(resource):
    """
    Extraemos la información extendida de un recurso reconocido de reddit, que
    podrá contener texto o imagen. Utilizamos el reddit_parser.py para extraerla
    y componer la plantilla que irá guardada como string en la base de datos
    """

    info = ""

    # Recuperamos el subreddit y el id del comentario y con ello componemos la url del .json
    subreddit = resource.split('/')[1]
    resource_id = resource.split('/')[3]

    url = "https://www.reddit.com/r/" + subreddit + "/comments/" + resource_id + "/.json"
    # Abrimos el archivo json y lo parseamos
    try:
        jsonStreamReddit = urllib.request.urlopen(url)
        reddit = RedditParser(jsonStreamReddit)
        information = reddit.info()

        # Extraemos la url de la información para ver si se trata de un comentario de texto
        # o de una imagen
        url = information['url']
        pattern = re.compile("https://i.redd.it/.+")

        # componemos el html con la información extendida, diferenciando si es texto o imagen
        if pattern.match(url):
            info = data.REDD_IMG.format(titulo=information['titulo'],
                                        subreddit=information['subreddit'],
                                        url=url,
                                        aprobacion=information['aprobacion'])
        else:
            info = data.REDD_TEXT.format(titulo=information['titulo'],
                                         subreddit=information['subreddit'],
                                         texto=information['texto'],
                                         url=url,
                                         aprobacion=information['aprobacion'])

    except urllib.error.HTTPError as err:
        print("catched: " + str(type(err)))
        print('HTTPError: {}'.format(err.code))
        pass
    except urllib.error.URLError as err:
        print("catched: " + str(type(err)))
        print('HTTPError: {}'.format(err.code))
        pass

    return info


@csrf_exempt
def processPageInfo(og, title):
    """
    Extraemos la información HTML de un recurso no reconocido a partir de las propiedades OpenGraph
    y HTML, formateamos la información y la guardamos en la base de datos
    """
    # Si existen propiedades OpenGraph de título, imagen, o ambas
    if og != {}:
        if "og_title" in og:
            titulo = og['og_title']
        else:
            titulo = ""

        if "og_img" in og:
            imagen = og['og_img']
        else:
            imagen = ""
        info = data.OG.format(titulo=titulo, imagen=imagen)

    # Si no hay propiedades OG, pero sí tiene título
    elif title != {}:
        info = data.TITLE.format(titulo=title['title'])

    # Si no tiene nada de la información anterior
    else:
        info = data.NO_INFO.format()

    return info


@csrf_exempt
def index(request):
    """
    Procesa las peticiones al recurso raiz de la aplicacion.
    """
    username = request.user.username
    global css_file

    # Si se ha hecho un POST sobre el recurso raiz
    if request.method == "POST":

        # Si el POST es para añadir contenido
        if request.POST['action'] == "Add content":

            # Dividimos la url en sitio (site) y recurso (resource)
            url = request.POST['url']

            # Eliminamos el indicador de protocolo http:// si lo tuviera
            if url.startswith('https://') or url.startswith('http://'):
                url = url.split('//', maxsplit=1)[1]

            # Diseccionamos qué tipo de url tenemos
            if url == "":
                site = ""
                resource = ""
            elif url.find('/') == -1:
                site = url
                resource = ""
            else:

project/LoVisto/templates/LoVisto/allpage.html
{% extends "LoVisto/index.html" %}

{% block navbar %}
    <li class="nav-item">
        <a class="nav-link active" aria-current="page" href="/">Inicio</a>
    </li>
    <li class="nav-item">
        <a class="nav-link active" aria-current="page" href="/info">Información</a>
    </li>
    <li class="nav-item">
        <a class="nav-link active" aria-current="page" href="/?format=xml">Descarga como fichero XML</a>
    </li>
    <li class="nav-item">
        <a class="nav-link active" aria-current="page" href="/?format=json">Descarga como fichero JSON</a>
    </li>
    {% if request.user.is_authenticated %}
         <li class="nav-item">
             <form method="post" action='{{ page }}#{{ content.resource }}'>
                 <input class="btn btn-dark" type="submit" name="action" value="Cambiar modo">
                 <input type="hidden" name="resource" value="{{ content.resource}}">
             </form>
         </li>
     {% endif %}
{% endblock %}

{% block body %}
   <div id="aportacion" class="col-lg-9 col-md-7 col-sm-12">
       <div class="container-fluid pt-3" style="padding-bottom: 20px">
           <div class="card text-center bg-secondary text-white">
               <div class="card-header">
                   <h5>Todas las aportaciones</h5>
               </div>
               <ul class="list-group list-group-flush">
                   {% for content in contents %}
                       <li class="list-group-item">
                           <p class="resumida"><a href='{{ content.resource }}'>{{ content.title }}</a></p>
                       </li>
                   {% endfor %}
               </ul>
           </div>
       </div>
   </div>

{% endblock %}

{% block user %}
{% endblock %}

project/LoVisto/templates/LoVisto/resource.html
{% extends "LoVisto/index.html" %}

{% block body %}
    <div id="aportaciones" class="col-lg-9 col-md-7 col-sm-12">
        <div class="panel panel-primary">
            <div class="panel-heading text-center">
                <h2><a name='{{ content.resource }}'>{{ content.title }}</a></h2>
            </div>
            <div class="panel-body">
                <ul class="list-group">
                    <li class="list-group-item">
                        <p class="description">
                            {{ content.description }}
                        </p>
                    </li>
                    <li class="list-group-item text-center">
                        <!-- usarmos autoescape para que interprete el texto de la info en HTML-->
                        {% autoescape off %}
                        {{ content.info }}
                        {% endautoescape %}
                    </li>
                    <li class="list-group-item text-center">
                        <p class="datos">
                            Contribución de {{ content.user }}, enviada en {{ content.date }},
                            {{ content.comments}} comentarios,
                        </p>
                        <p class="votos">Positivos: {{ content.likes }}. Negativos: {{ content.dislikes }}</p>
                        <a class="btn btn-primary" href='/{{ content.resource }}' role="button">más info</a></p>
                    </li>
                    {% if request.user.is_authenticated %}
                        <li class="list-group-item text-center">
                            {% for vote in votes %}
                                {% if vote.content == content and vote.user == request.user.username %}
                            {% if vote.decision == 1 %}
                                <div class="center-text p-3 mb-40 bg-success text-white">Has votado like</div>
                                    {% elif vote.decision == -1 %}
                                        <div class="p-3 mb-2 bg-danger text-white">Has votado dislike</div>
                                    {% endif %}
                                {% endif %}
                            {% endfor %}

                            <p class="center-text">
                                <form method="post" action='{{ page }}#{{ content.resource }}'>
                                    <input type="submit" name="action" value="like" class="btn btn-outline-success"
                                           role="button">
                                    <input type="submit" name="action" value="dislike" class="btn btn-outline-danger"
                                           role="button">
                                    <input type="hidden" name="resource" value="{{ content.resource}}">
                                </form>
                            </p>
                        </li>
                    {% endif %}
                </ul>
            </div>
        </div>

        <div id="comentarios" class="panel panel-primary">
            <div class="panel-heading bg-secondary text-center">
               Comentarios
            </div>
            <div class="panel-body">
                <ul class="list-group">
                    {% for comment in content.comment_set.all %}
                    <li class="list-group-item">
                        <h4>{{ comment.title }}</h4>
                        <p class="cuerpo">{{ comment.body }}</p>
                        <p class="fecha">Comentario de {{ comment.user }}, enviado en {{ content.date }}</p>
                    </li>
                    {% endfor %}
                    <li class="list-group-item text-center">
                        <a href="/{{ content.resource }}?format=json" class="btn btn-dark">Descargar comentarios en json</a>
                    </li>
                </ul>
            </div>
        </div>

    </div>
{% endblock %}

{% block user %}
{% if request.user.is_authenticated %}
    <div class="container-fluid pt-3">
        <div class="card border-secondary">
            <div class="card-header bg-secondary text-white text-center">
                Añade nuevo comentario
            </div>
            <div class="card-body">
                {% csrf_token %}
                <form class="justify-content-center" id="addcontent" method="POST" action="#">
                    <div class="form-group">
                        <label class="sr-only">Título</label>
                        <input type='text' class="form-control" name='title'>
                    </div>
                    <div class="form-group">
                        <label class="sr-only">Contenido</label>
                        <input type='text' class="form-control" name='body'>
                    </div>
                    <button class="text-center btn btn-outline-dark btn-rounded" name="action" value="Add comment"
                            type="submit">Añadir comentario
                    </button>
                </form>
            </div>
        </div>
    </div>
{% endif %}
{% endblock %}

project/LoVisto/templates/LoVisto/userpage.html
{% extends "LoVisto/index.html" %}

{% block body %}
    {% if request.user.is_authenticated %}
        <div class="col-lg-3 col-md-6 col-sm-12">
            <div class="container-fluid pt-3" style="padding-bottom: 5%">
                <div class="card text-center bg-secondary text-white">
                    <div class="card-header">
                        <h5>Aportaciones</h5>
                    </div>
                    <ul class="list-group list-group-flush">
                        {% for usercontent in usercontents %}
                            <li class="list-group-item">
                                <p class="resumida"><a href='{{ usercontent.resource }}'>{{ usercontent.title }}</a></p>
                            </li>
                        {% endfor %}
                    </ul>
                </div>
            </div>
        </div>

        <div class="col-lg-4 col-md-6 col-sm-12">
            <div class="container-fluid pt-3" style="padding-bottom: 5%">
                <div class="card bg-secondary text-white">
                    <div class="card-header text-center">
                        <h5>Comentarios</h5>
                    </div>
                    <ul class="list-group list-group-flush">
                        {% for usercomment in usercomments %}
                            <li class="list-group-item">
                                <p class="comment_resumida"><b>Título: </b>{{ usercomment.title }}<br>
                                    <b>Contenido: </b>{{ usercomment.body }}<br>
                                </p>
                                <p>Realizado el {{ usercomment.date }}.Comentario referido a: <a
                                        href='{{ usercomment.content.resource }}'>{{ usercomment.content.title }}</a>
                                </p>
                            </li>
                        {% endfor %}
                    </ul>
                </div>
            </div>
        </div>

        <div class="col-lg-3 col-md-6 col-sm-12">
            <div class="container-fluid pt-3" style="padding-bottom: 5%">
                <div class="card bg-secondary text-white">
                    <div class="card-header text-center">
                        <h5>Aportaciones Votadas</h5>
                    </div>
                    <ul class="list-group list-group-flush">
                        {% for uservote in uservotes %}
                            <li class="list-group-item">
                                <p class="user_votes">
                                    Votado aporte: <a href='{{ uservote.content.resource }}'>{{ uservote.content.title }}</a> con un
                                    {% if uservote.get_decision_display == "like" %}
                                        <b class="text-success">like</b>
                                    {% elif uservote.get_decision_display == "dislike" %}
                                        <b class="text-danger">dislike</b>
                                    {% endif %}
                                </p>
                            </li>
                        {% endfor %}
                    </ul>
                </div>
            </div>
        </div>
    {% else %}
        <div class="col-12 text-center">
            <h5>You are not allowed to access this page. Please Login.</h5>
        </div>
    {% endif %}
{% endblock %}


<!-- Bloque con las funcionalidades de login-->
{% block loggedservices %}
    {% if request.user.is_authenticated %}
        <div class="col-lg-2 col-md-6 col-sm-12">
            <div class="container-fluid pt-3">
                <form method="POST" action="/logout">
                    <h6>Has iniciado sesión como {{ request.user.username }}.</h6>
                    <input type="submit" name="action" value="logout" class="btn btn-outline-dark btn-rounded"/>
                    <input type='hidden' name='redirurl' value='{{ page }}'>
                </form>
            </div>
        </div>
    {% else %}
        <div class="col-lg-4 col-md-4 col-sm-0"></div>
        <div class="col-lg-4 col-md-4 col-sm-12">
            <div class="container-fluid pt-3">
                <div class="card border-secondary">
                    <div class="card-header bg-secondary text-white text-center">
                        Inicio de sesión
                    </div>
                    <div class="card-body">
                        {% csrf_token %}
                        <form class="justify-content-center" id="login" method="POST"
                              action="/login_user">
                            <div class="form-group">
                                <label class="sr-only">Usuario</label>
                                <input type='text' class="form-control" name='username'>
                            </div>
                            <div class="form-group">
                                <label class="sr-only">Contraseña</label>
                                <input type='text' class="form-control" name='password'>
                            </div>
                            <input type='hidden' name='redirurl' value='{{ page }}'>
                            <button type="submit" name="action" value="login"
                                    class="btn btn-outline-dark btn-rounded">login
                            </button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
        <div class="col-lg-4 col-md-4 col-sm-0"></div>
    {% endif %}

    {% block user %}
    {% endblock %}

{% endblock %}